/**
 * dummy clue wrapper
 *
 * Created by Samuel Gratzl on 27.08.2015.
 */
/// <amd-dependency path='font-awesome' />
/// <amd-dependency path='bootstrap' />
import * as header from 'phovea_ui/src/header';
import * as prov from 'phovea_core/src/provenance';
import * as d3 from 'd3';
import { resolveImmediately } from 'phovea_core/src';
/**
 * factory method creating a CLUEWrapper instance
 * @param body
 * @param options
 * @returns {CLUEWrapper}
 */
export function create(body, options) {
    if (options === void 0) { options = {}; }
    header.create(body, {
        appLink: new header.AppHeaderLink(options.app || 'Caleydo'),
        inverse: true
    });
    var $main = d3.select(body).append('main').style('height', '92vh');
    var graph = prov.createDummy();
    return {
        on: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return 0;
        },
        $main: $main,
        graph: resolveImmediately(graph),
        jumpToStored: function () { return 0; }
    };
}
//# sourceMappingURL=dummy.js.map